%
%   main.m
%
%   MATLAB script file with the main program for solving constrained
%   nonlinear systems of equations by using the as_id function
%
%
%   The problems in the TestProblems folder are described through
%   the following functions (for none of the test problems the
%   exact Jacobian matrix is provided, finite differences
%   are always used):
%
%           - testproblem.m
%                function [y] = testproblem(x)
%                Input:
%                   x = point in which the function has to be evaluated
%                Output:
%                   y = F(x)
%           - Stestproblem.m
%                function [x,l,u] = Stestproblem(c)
%                Input:
%                   c = parameter for computing the initial guess
%                Output:
%                   x = initial guess
%                 l,u = lower and upper bounds
%
%
%

path(path,'TestProblems');

%
%   INITIALIZATION
%

%%%%%  MAXIT  MAXNF  TR   DELTA  SCALING  OUTFLAG  
parms=[300    1000   1     -1       0        2];
tol=[1e-6 0];

other_ig=1;
       
while other_ig ~=0 
      f=input('Name of test example: ');
      Sf=['S' f];
      other_pb=1;
      while other_pb~=0
            c=input('insert the scalar c to compute the initial guess: ');
            [x,l,u]=feval(Sf,c);
            ff=feval(f,x);
            fnrm=norm(ff);
            [sol,ierr,output,history,grad,diagnostic]=CoDoSol(x,f,l,u,tol,parms);
%
%   LOOP FOR NEW INITIAL GUESS
%
            other_pb=input('If you want to use a new initial guess type 1, else type 0: ');
      end
%
%   LOOP FOR NEW TEST EXAMPLE
%
      other_ig=input('If you want to solve a new problem, type 1, else type 0: ');
end