% Freudenstein and Roth function 
% ------------------------------ 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
% function [fvec,J]=froth(n,m,x,option)     
% Problem no. 2
% Dimensions -> n=2, m=2                           
% Standard starting point -> x=(0.5,-2)            
% Minima -> f=0 at (5,4)                           
%           f=48.9842... at (11.41...,-0.8968...)  
%                                                  
% Revised on 10/22/94 by Madhu Lamba               
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function RES = Froth(what,x)
  global NF_eval NJF_eval ;
  switch what

  case {'name','title'}
    RES = 'The Freudenstein and Roth Function.' ;

  case {'n','size'}
    RES = 2 ;

  case 'm'
    RES = 2 ;

  case {'init','start'}
    RES = [ 0.5, -2 ]' ;

  case 'solution'
    RES = [ 5, 4 ]' ;

  case 'F'
    NF_eval = NF_eval+1 ;
    RES = eval_F( x ) ;

  case 'JF'
    NJF_eval = NJF_eval+1;
    RES = eval_JF(x ) ;

  otherwise
    error(['The Freudenstein and Roth Function, bad argument:' what]) ;
  end ;

end

%*****************************************************************************80
function F = eval_F ( x )
  F = [ -13+x(1)+((5-x(2))*x(2)-2)*x(2) ; ...
        -29+x(1)+((x(2)+1)*x(2)-14)*x(2) ]; 
end

%*****************************************************************************80
function JF = eval_JF ( x )
  JF = [ 1, 10*x(2)-3*x(2)^2-2 ; ...
         1,  3*x(2)^2+2*x(2)-14  ] ;
end
