%
% Secant method
%
% Find a zero of fun(x) starting from x0 ed x1 (x0 <> x1)
% epsi is the tolerance used in stopping criteria
%
% On output the whole sequence of the iterations is returned.
%
function X = secant(fun,x0,x1,epsi)
  X  = [x0;x1] ;
  f0 = feval(fun,x0) ;
  f1 = feval(fun,x1) ;
  for i=1:100
    % advancing formula
    df   = (f1-f0)/(X(end)-X(end-1)) ;
    xnew = X(end) - f1/df ;

    % update vectors
    X  = [X ; xnew ] ;
    f0 = f1 ;
    f1 = feval(fun,xnew) ;
    
    % check convergence
    if abs(f1) < epsi ; break ; end ;
  end
end
