global Nf_eval Ng_eval Nh_eval ;

addpath('../utils') ;
addpath('../functions') ;
addpath('../linesearch') ;
addpath('../minimizer') ;

cgtype  = {'', 'Fletcher and Reeves, ', 'Polack and Ribiere, ', 'Polack and Ribiere N2, ' } ;
lsearch = {'Armijo Simple, ', 'Armijo, ', 'Wolfe, ' } ;

flist = GetFunctionToMinimize('list') ;

nok = 0 ;
tot = length(flist);
for i=1:tot
  fun      = flist{i};
  ok{i}    = 'failed' ;
  x0       = feval(fun, 'start') ;
  tit{i}   = feval(fun, 'title' ) ;
  niter{i} = 0 ;
  nf{i}    = 0 ;
  ng{i}    = 0 ;
  nh{i}    = 0 ;
  ls{i}    = '' ;
  for kk=1:9
    k = mod(kk-1,3)+1 ;
    j = floor((kk-1)/3)+2 ;
    Nf_eval = 0 ;
    Ng_eval = 0 ;
    Nh_eval = 0 ;
    [ierr,X,F,NG] = ConjugateGradientMinimization( fun, x0, ...
                                                   'linesearch', k, ...
                                                   'cgtype',     j, ...
                                                   'tol',        1E-8, ...
                                                   'maxiter',    1000 ) ;
    if ierr == 0
      nok      = nok + 1 ; 
      ok{i}    = 'ok' ;
      niter{i} = length(F)-1 ;
      nf{i}    = Nf_eval ;
      ng{i}    = Ng_eval ;
      nh{i}    = Nh_eval ;
      ls{i}    = lsearch{k} ;
      cg{i}    = cgtype{j} ;
      break ;
    end
  end
end

fprintf( 1, ' ok?    iter    nf     ng     nh\n' ) ;
for i=1:length(flist)
    fprintf( 1, '      +------+------+------+------+\n' ) ;
    fprintf( 1, '%6s| %4d | %4d | %4d | %4d | %s %s %s\n', ...
             ok{i}, ...
             niter{i}, ...
             nf{i}, ...
             ng{i}, ...
             nh{i}, ...
             ls{i}, ...
             cg{i}, ...
             tit{i} ) ;
end
fprintf( 1, '      +------+------+------+------+\n' ) ;
fprintf( 1, 'ok = %d on a total of %d (%g%%)\n', nok, tot, 100*nok/tot ) ;



