function TestDFSANE

global Nf_eval Ng_eval Nh_eval ;

addpath('../utils') ;
addpath('../functions') ;
addpath('../linesearch') ;
addpath('../nonlinear') ;

flist = GetFunctionToMinimize('list') ;
%flist = { @GregoryAndKarney,
%          @Powell3D,
%          @Rosenbrock } ;
nok = 0 ;
tot = length(flist) ;
for i=1:tot
  fun      = flist{i} ;
  n        = feval(fun, 'n') ;
  x0       = feval(fun, 'start') ;
  tit{i}   = feval(fun, 'title' ) ;
  disp( tit{i} ) ;
  Nf_eval = 0 ;
  Ng_eval = 0 ;
  Nh_eval = 0 ;

  l = -ones(n,1)*Inf ;
  u =  ones(n,1)*Inf ;
  parms = [1000,Inf,1,-2,0,1] ;

  for m=1:3
    [ierr,X,F]=dfsane(x0,fun,'method',m) ;
    if ierr == 0
      break ;
    end
  end

  mt{i} = m ;
  if ierr == 0
    nok      = nok + 1 ; 
    ok{i}    = 'ok' ;
    niter{i} = length(F) ;
    nf{i}    = Nf_eval ;
    ng{i}    = Ng_eval ;
    nh{i}    = Nh_eval ;
  else
    ok{i}    = 'failed' ;    
    niter{i} = length(F) ;
    nf{i}    = 0 ;
    ng{i}    = 0 ;
    nh{i}    = 0 ;
  end
end

fprintf( 1, ' ok?    iter    nf     ng     nh\n' ) ;
for i=1:length(flist)
  fprintf( 1, '      +------+------+------+------+\n' ) ;
  fprintf( 1, '%6s| %4d | %4d | %4d | %4d | %d %s\n',ok{i},niter{i},nf{i},ng{i},nh{i},mt{i},tit{i} ) ;
end
fprintf( 1, '      +------+------+------+------+\n' ) ;
fprintf( 1, 'ok = %d on a total of %d (%g%%)\n', nok, tot, 100*nok/tot ) ;

end
