global Nf_eval Ng_eval Nh_eval ;

addpath('../utils') ;
addpath('../functions') ;
addpath('../linesearch') ;
addpath('../minimizer') ;

flist = GetFunctionToMinimize('list') ;
%flist = { @GregoryAndKarney,
%          @Powell3D,
%          @Rosenbrock } ;
nok = 0 ;
tot = length(flist) ;
for i=1:tot
  fun    = flist{i} ;
  x0     = feval(fun, 'start') ;
  tit{i} = feval(fun, 'title' ) ;
  disp( tit{i} ) ;
  Nf_eval = 0 ;
  Ng_eval = 0 ;
  Nh_eval = 0 ;
  [ierr,X,F,NG] = LevenbergMarquardtMinimization( fun, x0, ...
                                                  'tol',        1E-6, ...
                                                  'maxiter',    1000 ) ;
  if ierr == 0
    nok      = nok + 1 ; 
    ok{i}    = 'ok' ;
    niter{i} = length(F) ;
    nf{i}    = Nf_eval ;
    ng{i}    = Ng_eval ;
    nh{i}    = Nh_eval ;
  else
    ok{i}    = 'failed' ;    
    niter{i} = 0 ;
    nf{i}    = 0 ;
    ng{i}    = 0 ;
    nh{i}    = 0 ;
  end
end

fprintf( 1, ' ok?    iter    nf     ng     nh\n' ) ;
for i=1:length(flist)
  fprintf( 1, '      +------+------+------+------+\n' ) ;
  fprintf( 1, '%6s| %4d | %4d | %4d | %4d | %s\n',ok{i},niter{i},nf{i},ng{i},nh{i},tit{i} ) ;
end
fprintf( 1, '      +------+------+------+------+\n' ) ;
fprintf( 1, 'ok = %d on a total of %d (%g%%)\n', nok, tot, 100*nok/tot ) ;
