function TestCoDoDol

global Nf_eval Ng_eval Nh_eval FUNZIONE ;

addpath('../utils') ;
addpath('../functions') ;
addpath('../linesearch') ;
addpath('../minimizer') ;
addpath('../nonlinear') ;

flist = GetFunctionToMinimize('list') ;
%flist = { @GregoryAndKarney,
%          @Powell3D,
%          @Rosenbrock } ;
%flist = { @DeJongF2 } ;
%flist = { @Rosenbrock } ;

lsearch = {'Armijo Simple, ', 'Armijo, ', 'Wolfe, ' } ;

nok = 0 ;
tot = length(flist) ;
for i=1:tot
  fun      = flist{i} ;
  FUNZIONE = fun ;
  n        = feval(fun, 'n') ;
  x0       = feval(fun, 'start') ;
  tit{i}   = feval(fun, 'title' ) ;
  disp( tit{i} ) ;

  l   = -ones(n,1)*Inf ;
  u   =  ones(n,1)*Inf ;
  ok{i}    = 'failed' ;    
  niter{i} = Inf ;
  nf{i}    = 0 ;
  ng{i}    = 0 ;
  nh{i}    = 0 ;
  nsc{i}   = '' ;
  ntr{i}   = '' ;
  for ls=1:3
    Nf_eval = 0 ;
    Ng_eval = 0 ;
    Nh_eval = 0 ;

    [ierr, X,F] = NewtonNonlinear( fun, x0, 'linesearch', ls, 'tol', 1E-8, 'maxiter', 1000 ) ;

    if ierr == 0
      if ~isfinite(niter{i}) 
        nok   = nok + 1 ;
        ok{i} = 'ok' ;
     end
     niter{i} = length(F) ;
     nf{i}    = Nf_eval ;
     ng{i}    = Ng_eval ;
     nh{i}    = Nh_eval ;
     nls{i}   = lsearch{ls} ;
    end
  end
end

fprintf( 1, ' ok?    iter    nf     ng     nh\n' ) ;
for i=1:length(flist)
  fprintf( 1, '      +------+------+------+------+\n' ) ;
  fprintf( 1, '%6s| %4d | %4d | %4d | %4d | %s %s\n',ok{i},niter{i},nf{i},ng{i},nh{i},nls{i},tit{i} ) ;
end
fprintf( 1, '      +------+------+------+------+\n' ) ;
fprintf( 1, 'ok = %d on a total of %d (%g%%)\n', nok, tot, 100*nok/tot ) ;

end